Index: tools/h5dump/h5dump.c
===================================================================
--- tools/h5dump/h5dump.c	(revision 18506)
+++ tools/h5dump/h5dump.c	(working copy)
@@ -4510,7 +4516,7 @@
     table_list_free();
 
     if (H5Fclose(fid) < 0)
-        d_status = EXIT_FAILURE;
+        h5tools_setstatus( EXIT_FAILURE);
 
     free_handler(hand, argc);
 
@@ -4521,7 +4527,7 @@
 
     H5Eset_auto2(H5E_DEFAULT, func, edata);
 
-    leave(d_status);
+    leave(h5tools_getstatus());
 }
 
 /*-------------------------------------------------------------------------
@@ -4934,7 +4940,7 @@
             free(dtxid);
         } else {
             printf("<!-- h5dump error: unknown committed type. -->\n");
-            d_status = EXIT_FAILURE;
+            h5tools_setstatus( EXIT_FAILURE);
         }
     } else {
 
@@ -5238,7 +5244,7 @@
 
             default:
                 printf("<!-- unknown datatype -->");
-                d_status = EXIT_FAILURE;
+                h5tools_setstatus( EXIT_FAILURE);
                 break;
         }
     } /* end else */
@@ -5620,7 +5626,7 @@
         printf("<!-- h5dump error: unable to open attribute. -->\n");
         indentation(indent);
         printf("</%sAttribute>\n", xmlnsprefix );
-        d_status = EXIT_FAILURE;
+        h5tools_setstatus( EXIT_FAILURE);
         return FAIL;
     }
 }
@@ -5695,9 +5701,9 @@
 
             if (found_obj == NULL) {
                 indentation(indent);
-                    error_msg(progname, "internal error (file %s:line %d)\n",
+                    error_msg(h5tools_getprogname(), "internal error (file %s:line %d)\n",
                               __FILE__, __LINE__);
-                d_status = EXIT_FAILURE;
+                h5tools_setstatus( EXIT_FAILURE);
                 goto done;
             } else if(found_obj->displayed) {
                 /* We have already printed this named datatype, print it as a
@@ -5776,27 +5782,27 @@
 
     if ((gcpl_id = H5Gget_create_plist(gid)) < 0)
     {
-        error_msg(progname, "error in getting group creation property list ID\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in getting group creation property list ID\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     /* query the group creation properties for attributes */
     if (H5Pget_attr_creation_order(gcpl_id, &attr_crt_order_flags) < 0)
     {
-        error_msg(progname, "error in getting group creation properties\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in getting group creation properties\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     /* query the group creation properties */
     if(H5Pget_link_creation_order(gcpl_id, &crt_order_flags) < 0)
     {
-        error_msg(progname, "error in getting group creation properties\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in getting group creation properties\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     if(H5Pclose(gcpl_id) < 0) {
-        error_msg(progname, "error in closing group creation property list ID\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in closing group creation property list ID\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     if(HDstrcmp(name, "/") == 0) {
@@ -5828,9 +5834,9 @@
 
         if (found_obj == NULL) {
             indentation(indent);
-                error_msg(progname, "internal error (file %s:line %d)\n",
+                error_msg(h5tools_getprogname(), "internal error (file %s:line %d)\n",
                           __FILE__, __LINE__);
-            d_status = EXIT_FAILURE;
+            h5tools_setstatus( EXIT_FAILURE);
         } else {
             char *t_name = xml_escape_the_name(name);
             char *grpxid = malloc(100);
@@ -5895,14 +5901,14 @@
 
                 if((sort_by == H5_INDEX_CRT_ORDER) && (attr_crt_order_flags & H5P_CRT_ORDER_TRACKED)) {
                     if(H5Aiterate2(gid, sort_by, sort_order, NULL, dump_function_table->dump_attribute_function, NULL) < 0) {
-                        error_msg(progname, "error getting attribute information\n");
-                        d_status = EXIT_FAILURE;
+                        error_msg(h5tools_getprogname(), "error getting attribute information\n");
+                        h5tools_setstatus( EXIT_FAILURE);
                     } /* end if */
                 } /* end if */
                 else {
                     if(H5Aiterate2(gid, H5_INDEX_NAME, sort_order, NULL, dump_function_table->dump_attribute_function, NULL) < 0) {
-                        error_msg(progname, "error getting attribute information\n");
-                        d_status = EXIT_FAILURE;
+                        error_msg(h5tools_getprogname(), "error getting attribute information\n");
+                        h5tools_setstatus( EXIT_FAILURE);
                     } /* end if */
                 } /* end else */
 
@@ -5967,14 +5973,14 @@
 
         if((sort_by == H5_INDEX_CRT_ORDER) && (attr_crt_order_flags & H5P_CRT_ORDER_TRACKED)) {
             if(H5Aiterate2(gid, sort_by, sort_order, NULL, dump_function_table->dump_attribute_function, NULL) < 0) {
-                error_msg(progname, "error getting attribute information\n");
-                d_status = EXIT_FAILURE;
+                error_msg(h5tools_getprogname(), "error getting attribute information\n");
+                h5tools_setstatus( EXIT_FAILURE);
             } /* end if */
         } /* end if */
         else {
             if(H5Aiterate2(gid, H5_INDEX_NAME, sort_order, NULL, dump_function_table->dump_attribute_function, NULL) < 0) {
-                error_msg(progname, "error getting attribute information\n");
-                d_status = EXIT_FAILURE;
+                error_msg(h5tools_getprogname(), "error getting attribute information\n");
+                h5tools_setstatus( EXIT_FAILURE);
             } /* end if */
         } /* end else */
 
@@ -6633,14 +6639,14 @@
 
     if((sort_by == H5_INDEX_CRT_ORDER) && (attr_crt_order_flags & H5P_CRT_ORDER_TRACKED)) {
         if(H5Aiterate2(did, sort_by, sort_order, NULL, dump_function_table->dump_attribute_function, NULL) < 0) {
-            error_msg(progname, "error getting attribute information\n");
-            d_status = EXIT_FAILURE;
+            error_msg(h5tools_getprogname(), "error getting attribute information\n");
+            h5tools_setstatus( EXIT_FAILURE);
         } /* end if */
     } /* end if */
     else {
         if(H5Aiterate2(did, H5_INDEX_NAME, sort_order, NULL, dump_function_table->dump_attribute_function, NULL) < 0) {
-            error_msg(progname, "error getting attribute information\n");
-            d_status = EXIT_FAILURE;
+            error_msg(h5tools_getprogname(), "error getting attribute information\n");
+            h5tools_setstatus( EXIT_FAILURE);
         } /* end if */
     } /* end else */
 
@@ -7073,7 +7079,7 @@
                 handle_datatypes(group, linkname, NULL, 0, objname);
                 break;
             default:
-                d_status = EXIT_FAILURE;
+                h5tools_setstatus( EXIT_FAILURE);
         }
 
         indent -= 2*COL;
@@ -7088,7 +7094,7 @@
     } /* end if */
 
     if (H5Idec_ref(oid) < 0)
-        d_status = EXIT_FAILURE;
+        h5tools_setstatus( EXIT_FAILURE);
 
 
     return SUCCEED;
Index: tools/h5repack/h5repack.c
===================================================================
--- tools/h5repack/h5repack.c	(revision 18506)
+++ tools/h5repack/h5repack.c	(working copy)
@@ -23,7 +23,7 @@
 #include "h5tools_utils.h"
 
 
-extern char  *progname;
+/*extern char  *progname;*/
 
 
 /*-------------------------------------------------------------------------
@@ -157,7 +157,7 @@
 
         if(options->n_filter_g > H5_REPACK_MAX_NFILTERS)
         {
-            error_msg(progname, "maximum number of filters exceeded for <%s>\n", str);
+            error_msg(h5tools_getprogname(), "maximum number of filters exceeded for <%s>\n", str);
             free(obj_list);
             return -1;
         }
@@ -195,7 +195,7 @@
     init_packobject(&pack);
 
     if (options->all_layout==1){
-        error_msg(progname, "invalid layout input: 'all' option \
+        error_msg(h5tools_getprogname(), "invalid layout input: 'all' option \
                             is present with other objects <%s>\n",str);
         return -1;
     }
@@ -614,7 +614,7 @@
                 break;
             case H5D_LAYOUT_ERROR:
             case H5D_NLAYOUTS:
-                error_msg(progname, "invalid layout\n");
+                error_msg(h5tools_getprogname(), "invalid layout\n");
                 return -1;
             default:
                 strcpy(slayout,"invalid layout\n");
@@ -655,7 +655,7 @@
 
     if (options->all_layout==1 && has_ck)
     {
-        error_msg(progname, "invalid chunking input: 'all' option\
+        error_msg(h5tools_getprogname(), "invalid chunking input: 'all' option\
                             is present with other objects\n");
         return -1;
     }
@@ -717,7 +717,7 @@
 
     if (options->all_filter==1 && has_cp)
     {
-        error_msg(progname, "invalid compression input: 'all' option\
+        error_msg(h5tools_getprogname(), "invalid compression input: 'all' option\
                             is present with other objects\n");
         return -1;
     }
@@ -729,24 +729,24 @@
 
     if (options->grp_compact < 0)
     {
-        error_msg(progname, "invalid maximum number of links to store as header messages\n");
+        error_msg(h5tools_getprogname(), "invalid maximum number of links to store as header messages\n");
         return -1;
     }
     if (options->grp_indexed < 0)
     {
-        error_msg(progname, "invalid minimum number of links to store in the indexed format\n");
+        error_msg(h5tools_getprogname(), "invalid minimum number of links to store in the indexed format\n");
         return -1;
     }
     if (options->grp_indexed > options->grp_compact)
     {
-        error_msg(progname, "minimum indexed size is greater than the maximum compact size\n");
+        error_msg(h5tools_getprogname(), "minimum indexed size is greater than the maximum compact size\n");
         return -1;
     }
     for (i=0; i<8; i++)
     {
         if (options->msg_size[i]<0)
         {
-            error_msg(progname, "invalid shared message size\n");
+            error_msg(h5tools_getprogname(), "invalid shared message size\n");
             return -1;
         }
     }
@@ -768,7 +768,7 @@
 
     if ( options->ublock_filename == NULL && options->ublock_size != 0 )
     {
-        error_msg(progname, "file name missing for user block\n",
+        error_msg(h5tools_getprogname(), "file name missing for user block\n",
             options->ublock_filename);
         return -1;
     }
@@ -781,7 +781,7 @@
 
     if ( options->alignment == 0 && options->threshold != 0 )
     {
-        error_msg(progname, "alignment for H5Pset_alignment missing\n");
+        error_msg(h5tools_getprogname(), "alignment for H5Pset_alignment missing\n");
         return -1;
     }
 
@@ -853,7 +853,7 @@
         /* the input object names are present in the file and are valid */
         if(h5trav_getindext(name, travt) < 0)
         {
-            error_msg(progname, "%s Could not find <%s> in file <%s>. Exiting...\n",
+            error_msg(h5tools_getprogname(), "%s Could not find <%s> in file <%s>. Exiting...\n",
                 (options->verbose?"\n":""),name,fname);
             goto out;
         }
@@ -975,7 +975,7 @@
     else if (filtn==H5Z_FILTER_SCALEOFFSET)
         return "SOFF";
     else {
-        error_msg(progname, "input error in filter type\n");
+        error_msg(h5tools_getprogname(), "input error in filter type\n");
         exit(EXIT_FAILURE);
     }
 }
Index: tools/h5repack/h5repack_main.c
===================================================================
--- tools/h5repack/h5repack_main.c	(revision 18506)
+++ tools/h5repack/h5repack_main.c	(working copy)
@@ -17,6 +17,7 @@
 #include <string.h>
 #include <ctype.h>
 
+#include "h5tools.h"
 #include "h5tools_utils.h"
 #include "h5repack.h"
 
@@ -27,8 +28,9 @@
 
 
 /* module-scoped variables */
-const char  *progname = "h5repack";
-int         d_status = EXIT_SUCCESS;
+/*const char  *progname = "h5repack";*/
+/*int         d_status = EXIT_SUCCESS;*/
+
 static int  has_i_o = 0;
 const char  *infile  = NULL;
 const char  *outfile = NULL;
@@ -105,6 +107,8 @@
     pack_opt_t    options;            /*the global options */
     int           ret=-1;
 
+	h5tools_setprogname("h5repack");
+	h5tools_setstatus(EXIT_SUCCESS);
     /* initialize options  */
     h5repack_init (&options,0);
 
@@ -121,8 +125,8 @@
 
             if ( strcmp( infile, outfile ) == 0 )
             {
-                error_msg(progname, "file names cannot be the same\n");
-                usage(progname);
+                error_msg(h5tools_getprogname(), "file names cannot be the same\n");
+                usage(h5tools_getprogname());
                 exit(EXIT_FAILURE);
 
             }
@@ -130,8 +134,8 @@
 
         else
         {
-            error_msg(progname, "file names missing\n");
-            usage(progname);
+            error_msg(h5tools_getprogname(), "file names missing\n");
+            usage(h5tools_getprogname());
             exit(EXIT_FAILURE);
         }
     }
@@ -304,10 +308,10 @@
 
 
         case 'h':
-            usage(progname);
+            usage(h5tools_getprogname());
             exit(EXIT_SUCCESS);
         case 'V':
-            print_version(progname);
+            print_version(h5tools_getprogname());
             exit(EXIT_SUCCESS);
         case 'v':
             options->verbose = 1;
@@ -317,7 +321,7 @@
             /* parse the -f filter option */
             if (h5repack_addfilter( opt_arg, options)<0)
             {
-                error_msg(progname, "in parsing filter\n");
+                error_msg(h5tools_getprogname(), "in parsing filter\n");
                 exit(EXIT_FAILURE);
             }
             break;
@@ -326,7 +330,7 @@
             /* parse the -l layout option */
             if (h5repack_addlayout( opt_arg, options)<0)
             {
-                error_msg(progname, "in parsing layout\n");
+                error_msg(h5tools_getprogname(), "in parsing layout\n");
                 exit(EXIT_FAILURE);
             }
             break;
@@ -337,7 +341,7 @@
             options->min_comp = atoi( opt_arg );
             if ((int)options->min_comp<=0)
             {
-                error_msg(progname, "invalid minimum compress size <%s>\n", opt_arg );
+                error_msg(h5tools_getprogname(), "invalid minimum compress size <%s>\n", opt_arg );
                 exit(EXIT_FAILURE);
             }
             break;
@@ -430,7 +434,7 @@
             options->alignment = atol( opt_arg );
             if ( options->alignment < 1 )
             {
-                error_msg(progname, "invalid alignment size\n", opt_arg );
+                error_msg(h5tools_getprogname(), "invalid alignment size\n", opt_arg );
                 exit(EXIT_FAILURE);
             }
             break;
@@ -445,8 +449,8 @@
         /* check for file names to be processed */
         if (argc <= opt_ind || argv[ opt_ind + 1 ] == NULL)
         {
-            error_msg(progname, "missing file names\n");
-            usage(progname);
+            error_msg(h5tools_getprogname(), "missing file names\n");
+            usage(h5tools_getprogname());
             exit(EXIT_FAILURE);
         }
     }
@@ -489,7 +493,7 @@
 
 
     if ((fp = fopen(data_file, "r")) == (FILE *)NULL) {
-        error_msg(progname, "cannot open options file %s\n", filename);
+        error_msg(h5tools_getprogname(), "cannot open options file %s\n", filename);
         exit(EXIT_FAILURE);
     }
 
@@ -526,7 +530,7 @@
             comp_info[i-1]='\0'; /*cut the last " */
 
             if (h5repack_addfilter(comp_info,options)==-1){
-                error_msg(progname, "could not add compression option\n");
+                error_msg(h5tools_getprogname(), "could not add compression option\n");
                 exit(EXIT_FAILURE);
             }
         }
@@ -556,7 +560,7 @@
             comp_info[i-1]='\0'; /*cut the last " */
 
             if (h5repack_addlayout(comp_info,options)==-1){
-                error_msg(progname, "could not add chunck option\n");
+                error_msg(h5tools_getprogname(), "could not add chunck option\n");
                 exit(EXIT_FAILURE);
             }
         }
@@ -565,7 +569,7 @@
         *-------------------------------------------------------------------------
         */
         else {
-            error_msg(progname, "bad file format for %s", filename);
+            error_msg(h5tools_getprogname(), "bad file format for %s", filename);
             exit(EXIT_FAILURE);
         }
     }
Index: tools/h5repack/h5repack_verify.c
===================================================================
--- tools/h5repack/h5repack_verify.c	(revision 18506)
+++ tools/h5repack/h5repack_verify.c	(working copy)
@@ -15,9 +15,10 @@
 
 #include "h5repack.h"
 #include "h5test.h"
+#include "h5tools.h"
 #include "h5tools_utils.h"
 
-extern char  *progname;
+/*extern char  *progname;*/
 static int verify_layout(hid_t pid, pack_info_t *obj);
 static int verify_filters(hid_t pid, hid_t tid, int nfilters, filter_info_t *filter);
 
@@ -313,12 +314,12 @@
         /* Open the files */
         if ((fid1=H5Fopen(fname1,H5F_ACC_RDONLY,H5P_DEFAULT)) < 0 )
         {
-            error_msg(progname, "<%s>: %s\n", fname1, H5FOPENERROR );
+            error_msg(h5tools_getprogname(), "<%s>: %s\n", fname1, H5FOPENERROR );
             return -1;
         }
         if ((fid2=H5Fopen(fname2,H5F_ACC_RDONLY,H5P_DEFAULT)) < 0 )
         {
-            error_msg(progname, "<%s>: %s\n", fname2, H5FOPENERROR );
+            error_msg(h5tools_getprogname(), "<%s>: %s\n", fname2, H5FOPENERROR );
             H5Fclose(fid1);
             return -1;
         }
@@ -367,7 +368,7 @@
 
             if ( crt_order_flag1 != crt_order_flag2 )
             {
-                error_msg(progname, "property lists for <%s> are different\n",trav->objs[i].name);
+                error_msg(h5tools_getprogname(), "property lists for <%s> are different\n",trav->objs[i].name);
                 goto error;
             }
 
@@ -395,7 +396,7 @@
 
             if(ret == 0)
             {
-                error_msg(progname, "property lists for <%s> are different\n",trav->objs[i].name);
+                error_msg(h5tools_getprogname(), "property lists for <%s> are different\n",trav->objs[i].name);
                 goto error;
             }
 
Index: tools/h5repack/h5repack_copy.c
===================================================================
--- tools/h5repack/h5repack_copy.c	(revision 18506)
+++ tools/h5repack/h5repack_copy.c	(working copy)
@@ -30,7 +30,7 @@
 * globals
 *-------------------------------------------------------------------------
 */
-extern char  *progname;
+/*extern char  *progname;*/
 
 /*-------------------------------------------------------------------------
 * macros
@@ -90,7 +90,7 @@
     */
     if((fidin = h5tools_fopen(fnamein, H5F_ACC_RDONLY, H5P_DEFAULT, NULL, NULL, (size_t)0)) < 0)
     {
-        error_msg(progname, "<%s>: %s\n", fnamein, H5FOPENERROR );
+        error_msg(h5tools_getprogname(), "<%s>: %s\n", fnamein, H5FOPENERROR );
         goto out;
     }
 
@@ -100,19 +100,19 @@
 
         if((fcpl_in = H5Fget_create_plist(fidin)) < 0)
         {
-            error_msg(progname, "failed to retrieve file creation property list\n");
+            error_msg(h5tools_getprogname(), "failed to retrieve file creation property list\n");
             goto out;
         }
 
         if(H5Pget_userblock(fcpl_in, &ub_size) < 0)
         {
-            error_msg(progname, "failed to retrieve userblock size\n");
+            error_msg(h5tools_getprogname(), "failed to retrieve userblock size\n");
             goto out;
         }
 
         if(H5Pclose(fcpl_in) < 0)
         {
-            error_msg(progname, "failed to close property list\n");
+            error_msg(h5tools_getprogname(), "failed to close property list\n");
             goto out;
         }
     }
@@ -123,7 +123,7 @@
         /* Create file creation property list */
         if((fcpl = H5Pcreate(H5P_FILE_CREATE)) < 0)
         {
-            error_msg(progname, "fail to create a file creation property list\n");
+            error_msg(h5tools_getprogname(), "fail to create a file creation property list\n");
             goto out;
         }
 
@@ -131,7 +131,7 @@
         {
             if(H5Pset_userblock(fcpl, ub_size) < 0)
             {
-                error_msg(progname, "failed to set non-default userblock size\n");
+                error_msg(h5tools_getprogname(), "failed to set non-default userblock size\n");
                 goto out;
             }
         }
@@ -144,7 +144,7 @@
             /* (So that it is created in "dense storage" form) */
             if(H5Pset_link_phase_change(fcpl, (unsigned)options->grp_compact, (unsigned)options->grp_indexed) < 0)
             {
-                error_msg(progname, "fail to adjust group creation parameters for root group\n");
+                error_msg(h5tools_getprogname(), "fail to adjust group creation parameters for root group\n");
                 goto out;
             }
 
@@ -186,7 +186,7 @@
             {
                 if(H5Pset_shared_mesg_nindexes(fcpl, nindex) < 0)
                 {
-                    error_msg(progname, "fail to set the number of shared object header message indexes\n");
+                    error_msg(h5tools_getprogname(), "fail to set the number of shared object header message indexes\n");
                     goto out;
                 }
 
@@ -194,7 +194,7 @@
                 for(i = 0; i < (nindex - 1); i++)
                 {
                     if(H5Pset_shared_mesg_index(fcpl, i, mesg_type_flags[i], min_mesg_sizes[i]) < 0) {
-                        error_msg(progname, "fail to configure the specified shared object header message index\n");
+                        error_msg(h5tools_getprogname(), "fail to configure the specified shared object header message index\n");
                         goto out;
                     } /* end if */
                 } /* end for */
@@ -203,13 +203,13 @@
             /* Create file access property list */
             if((fapl = H5Pcreate(H5P_FILE_ACCESS)) < 0)
             {
-                error_msg(progname, "Could not create file access property list\n");
+                error_msg(h5tools_getprogname(), "Could not create file access property list\n");
                 goto out;
             } /* end if */
 
             if(H5Pset_libver_bounds(fapl, H5F_LIBVER_LATEST, H5F_LIBVER_LATEST) < 0)
             {
-                error_msg(progname, "Could not set property for using latest version of the format\n");
+                error_msg(h5tools_getprogname(), "Could not set property for using latest version of the format\n");
                 goto out;
             } /* end if */
         } /* end if */
@@ -236,7 +236,7 @@
             /* set user block size */
             if(H5Pset_userblock(fcpl, options->ublock_size) < 0)
             {
-                error_msg(progname, "failed to set userblock size\n");
+                error_msg(h5tools_getprogname(), "failed to set userblock size\n");
                 goto out;
             }
 
@@ -248,14 +248,14 @@
             /* create a file creation property list */
             if((fcpl = H5Pcreate(H5P_FILE_CREATE)) < 0)
             {
-                error_msg(progname, "fail to create a file creation property list\n");
+                error_msg(h5tools_getprogname(), "fail to create a file creation property list\n");
                 goto out;
             }
 
             /* set user block size */
             if(H5Pset_userblock(fcpl, options->ublock_size) < 0)
             {
-                error_msg(progname, "failed to set userblock size\n");
+                error_msg(h5tools_getprogname(), "failed to set userblock size\n");
                 goto out;
             }
 
@@ -280,7 +280,7 @@
 
             if (H5Pset_alignment(fapl, options->threshold, options->alignment) < 0)
             {
-                error_msg(progname, "failed to set alignment\n");
+                error_msg(h5tools_getprogname(), "failed to set alignment\n");
                 goto out;
             }
 
@@ -292,13 +292,13 @@
             /* create a file access property list */
             if ((fapl = H5Pcreate(H5P_FILE_ACCESS)) < 0)
             {
-                error_msg(progname, "Could not create file access property list\n");
+                error_msg(h5tools_getprogname(), "Could not create file access property list\n");
                 goto out;
             }
 
             if (H5Pset_alignment(fapl, options->threshold, options->alignment) < 0)
             {
-                error_msg(progname, "failed to set alignment\n");
+                error_msg(h5tools_getprogname(), "failed to set alignment\n");
                 goto out;
             }
 
@@ -319,7 +319,7 @@
 
     if((fidout = H5Fcreate(fnameout,H5F_ACC_TRUNC, fcpl, fapl)) < 0)
     {
-        error_msg(progname, "<%s>: Could not create file\n", fnameout );
+        error_msg(h5tools_getprogname(), "<%s>: Could not create file\n", fnameout );
         goto out;
     }
 
@@ -332,7 +332,7 @@
     {
         if ( copy_user_block( options->ublock_filename, fnameout, options->ublock_size) < 0 )
         {
-            error_msg(progname, "Could not copy user block. Exiting...\n");
+            error_msg(h5tools_getprogname(), "Could not copy user block. Exiting...\n");
             goto out;
 
         }
@@ -356,7 +356,7 @@
     */
     if(do_copy_objects(fidin, fidout, travt, options) < 0)
     {
-        error_msg(progname, "<%s>: Could not copy data to: %s\n", fnamein, fnameout);
+        error_msg(h5tools_getprogname(), "<%s>: Could not copy data to: %s\n", fnamein, fnameout);
         goto out;
     } /* end if */
 
@@ -398,7 +398,7 @@
     {
         if ( copy_user_block(fnamein, fnameout, ub_size) < 0 )
         {
-            error_msg(progname, "Could not copy user block. Exiting...\n");
+            error_msg(h5tools_getprogname(), "Could not copy user block. Exiting...\n");
             goto out;
 
         }
@@ -1362,19 +1362,19 @@
     /* get user block size */
     if(( fcpl = H5Fget_create_plist(fid)) < 0)
     {
-        error_msg(progname, "failed to retrieve file creation property list\n");
+        error_msg(h5tools_getprogname(), "failed to retrieve file creation property list\n");
         goto done;
     }
 
     if(H5Pget_userblock(fcpl, &ub_size) < 0)
     {
-        error_msg(progname, "failed to retrieve userblock size\n");
+        error_msg(h5tools_getprogname(), "failed to retrieve userblock size\n");
         goto done;
     }
 
     if(H5Pclose(fcpl) < 0)
     {
-        error_msg(progname, "failed to close property list\n");
+        error_msg(h5tools_getprogname(), "failed to close property list\n");
         goto done;
     }
 
Index: tools/h5repack/h5repack_opttable.c
===================================================================
--- tools/h5repack/h5repack_opttable.c	(revision 18506)
+++ tools/h5repack/h5repack_opttable.c	(working copy)
@@ -16,9 +16,10 @@
 #include <stdlib.h>
 #include <string.h>
 #include "h5repack.h"
+#include "h5tools.h"
 #include "h5tools_utils.h"
 
-extern char  *progname;
+/*extern char  *progname;*/
 
 /*-------------------------------------------------------------------------
  * Function: init_packobject
@@ -67,7 +68,7 @@
     }
     else
     {
-    error_msg(progname, "cannot insert the filter in this object.\
+    error_msg(h5tools_getprogname(), "cannot insert the filter in this object.\
         Maximum capacity exceeded\n");
     }
 }
@@ -126,7 +127,7 @@
     table->size += n_objs;
     table->objs = (pack_info_t*)realloc(table->objs, table->size * sizeof(pack_info_t));
     if (table->objs==NULL) {
-        error_msg(progname, "not enough memory for options table\n");
+        error_msg(h5tools_getprogname(), "not enough memory for options table\n");
         return -1;
     }
     for (i = table->nelems; i < table->size; i++)
@@ -153,7 +154,7 @@
 
     if(NULL == (table = (pack_opttbl_t *)malloc(sizeof(pack_opttbl_t))))
     {
-        error_msg(progname, "not enough memory for options table\n");
+        error_msg(h5tools_getprogname(), "not enough memory for options table\n");
         return -1;
     }
 
@@ -161,7 +162,7 @@
     table->nelems = 0;
     if(NULL == (table->objs = (pack_info_t*)malloc(table->size * sizeof(pack_info_t))))
     {
-        error_msg(progname, "not enough memory for options table\n");
+        error_msg(h5tools_getprogname(), "not enough memory for options table\n");
         free(table);
         return -1;
     }
@@ -232,7 +233,7 @@
                     /* already chunk info inserted for this one; exit */
                     if (table->objs[i].chunk.rank>0)
                     {
-                        error_msg(progname, "chunk information already inserted for <%s>\n",obj_list[j].obj);
+                        error_msg(h5tools_getprogname(), "chunk information already inserted for <%s>\n",obj_list[j].obj);
                         exit(EXIT_FAILURE);
                     }
                     /* insert the layout info */
